"use strict";

var _ = require('lodash');
var _require = require('@forestadmin/context'),
  inject = _require.inject;
function IntegrationInformationsGetter(modelName, Implementation, integration) {
  var _inject = inject(),
    modelsManager = _inject.modelsManager;
  this.perform = function () {
    var models = modelsManager.getModels();
    var value = null;
    _.each(integration.mapping, function (mappingValue) {
      var collectionName = mappingValue.split('.')[0];
      if (models[collectionName] && Implementation.getModelName(models[collectionName]) === modelName) {
        value = mappingValue;
      }
    });
    return value;
  };
}
module.exports = IntegrationInformationsGetter;